      program main
c    
      use parallelism
      use projection_engine
      use communicators
c
      implicit none
c
      include 'dmumps_struc.h'
      include 'mpif.h'
#include 'fpapi.h'
c
      save
      type(dmumps_struc) :: mumps_par

c
      integer(kind=4) :: n, p, nelem, l
      real   (kind=8), allocatable, dimension(:) :: U
      double precision, allocatable, dimension(:,:) :: M
c-> NEW
      double precision, allocatable, dimension(:) :: A
      integer, allocatable, dimension(:) :: IRN
      integer, allocatable, dimension(:) :: JCN
      integer :: nr_nonzeros
c<- NEW
      double precision, allocatable, dimension(:,:) :: F
      double precision, allocatable, dimension(:,:) :: Result
      integer, allocatable, dimension(:) :: dimensionsX
      integer, allocatable, dimension(:) :: dimensionsY
      integer, allocatable, dimension(:) :: dimensionsZ
      integer, allocatable, dimension(:) :: shiftsX
      integer, allocatable, dimension(:) :: shiftsY
      integer, allocatable, dimension(:) :: shiftsZ
      integer :: Fsize,Fsize_out
c
      integer, allocatable, dimension(:) :: IPIV
      integer :: KL, KU
      integer :: nrcppx,nrcppy,nrcppz
      integer :: ibegx,iendx,ibegy,iendy,ibegz,iendz
      integer :: i,j,k,nzero,ind
      integer :: iret,ierr
      integer :: idebug,iprint,iinfo
      integer :: iclock,iclock_init
      integer :: iclock_gather1,iclock_gather2,iclock_gather3
      integer :: iclock_solve1,iclock_solve2,iclock_solve3
      integer :: iclock_scatter1,iclock_scatter2,iclock_scatter3
      integer :: iclock_i1,iclock_i2,iclock_i3,iclock_i4
      double precision ::dtime,dtime_init
      double precision ::dtime_gather1,dtime_gather2,dtime_gather3
      double precision ::dtime_scatter1,dtime_scatter2,dtime_scatter3
      double precision ::dtime_solve1,dtime_solve2,dtime_solve3
      double precision ::dtime_i1,dtime_i2,dtime_i3,dtime_i4
      
      real :: real_time,proc_time,mflops
      integer :: retval, check
      integer*8 :: flpins
      integer :: events(2), numevents
      character*(PAPI_MAX_STR_LEN) :: errorstring
      integer*8 :: values (2)
      integer :: measure
      character(100) :: input

      idebug=0
      iprint=0
      iinfo=1
c
      call start_clock(iclock)
      
      
      call getarg(1, input)
      read (input, *) measure
      call getarg(2, input)
      read (input, *) nrprocall
      call getarg(3, input)
      read (input, *) iinfo
      call getarg(4, input)
      read (input, *) ORDER
      call getarg(5, input)
      read (input, *) SIZE
      call getarg(6, input)
      read (input, *) IBLOCK
      write (*,*) 'measure ', measure, ' nrprocall ', nrprocall,
     .     ' iinfo ', iinfo
      write (*,*) ' p ', ORDER, ' n ', SIZE,
     .     ' iblocking ', IBLOCK

c      call initialize_parameters
      call initialize_parallelism
c      call create_communicators

      iprint=0
      
      if(MYRANK.eq.0)then
         write (*,*) 'start time'
         call timestamp('start')
      endif

c      Setup PAPI library and begin collecting data from the counters */
      numevents = 2
      events(1) = PAPI_LD_INS
      events(2) = PAPI_SR_INS
      if (measure.eq.1) then
      call PAPIF_flops(real_time, proc_time, flpins,mflops,retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write(*,*) 'PAPI started'
      endif
      if (measure.eq.2) then
         call PAPIF_library_init(check)
         call PAPIF_start_counters(events, numevents, retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write(*,*) 'PAPI started'
      endif
      
      call mpi_barrier(MPI_COMM_WORLD,ierr)
c
c      call create_grids
c
c      if(MYRANK.eq.0)iprint=1
      if(MYRANK.eq.0)iinfo=1
c
      if(iinfo.eq.1)write(*,*)PRINTRANK,'INITIALIZATION'
c
c  ...prepare the problem dimensions
      p=ORDER !order
      n=SIZE

c-> rIGA
        if(iinfo.eq.1)
     .     write(*,*)'n,p,IBLOCK',n,p,IBLOCK


      if(iblock.eq.0)then
      
c*************************************************************************
c********************** Inicjalizacja ************************************
c*************************************************************************
         
      allocate(U(n+p+2)) !knot vector
      U(1:p+1)=0.d0
      U(n+2:n+p+2)=1.d0
      do i=p+2,n+1
c        if(iprint.eq.1)then
c        write(*,*)'i-p-1,n,(i-p-1)/(n)',i-p-1,n,real(i-p-1)/real(n) !n-1 is number of intervals
c        endif
        U(i)=real(i-p-1)/real(n-1)
      enddo
c
      nelem = CountSpans(n,p,U)
      if(iinfo.eq.1)write(*,*)'nelem',nelem
      if(iinfo.eq.1)write(*,*)'U',U

      endif

c---------------------------------------------------------------------------
      if(iblock.gt.0.and.p.eq.2)then

      allocate(U(n+p+2)) !knot vector
      U(1:p+1)=0.d0
      U(n+2:n+p+2)=1.d0
      do i=p+2,n+1
c        if(iprint.eq.1)then
c        write(*,*)'i-p-1,n,(i-p-1)/(n)',i-p-1,n,real(i-p-1)/real(n) !n-1 is number of intervals
c        endif
        U(i)=real(i-p-1)/real(n-1)
      enddo
c
      nelem = CountSpans(n,p,U)
      if(iinfo.eq.1)write(*,*)'nelem',nelem
      if(iinfo.eq.1)write(*,*)'U',U


        deallocate(U)
        allocate(U(n+p+2+(nelem/iblock)*(p-1)))
        n=n+(nelem/iblock)*(p-1)-1
        if(iinfo.eq.1)
     .    write(*,*)'allocate(U(',n+p+1+(nelem/iblock)*(p-1),'))'
        U(1:p+1)=0.d0 
        i=p+2; l=1
        if(iinfo.eq.1)
     .     write(*,*)'IBLOCK,nelem',IBLOCK,nelem
        do j=1,nelem/IBLOCK 
          do k=0,IBLOCK-p 
            if(iinfo.eq.1)
     .        write(*,*)'U(',i+k,')=',real(l+k)/real(nelem)
            U(i+k)=real(l+k)/real(nelem)
          enddo
          if(j.lt.nelem/IBLOCK)then
            do k=IBLOCK-p+1,IBLOCK 
              if(iinfo.eq.1)
     .          write(*,*)'*U(',i+k,')=',real(l+IBLOCK-p+1)/real(nelem)
              U(i+k)=real(l+IBLOCK-p+1)/real(nelem)
            enddo
            i=i+IBLOCK+1;l=l+IBLOCK-p+2
          else
            i=i+IBLOCK+1-p
          endif
        enddo
        U(i:i+p)=1.d0
        if(iinfo.eq.1)then
          write(*,*)'n,p,nelem',n,p,nelem
          write(*,*)'U',U
        endif
      endif
c-------------------------------------------------------------------------
c      if(iblock.gt.0.and.p.eq.3)then
c
c      allocate(U(n+2*p)) !knot vector
c      U(1:p+1)=0.d0
c      U(n+p:n+2*p)=1.d0
c      do i=p+2,n+p-1
cc        if(iprint.eq.1)then
cc        write(*,*)'i-p-1,n,(i-p-1)/(n)',i-p-1,n,real(i-p-1)/real(n) !n-1 is number of intervals
cc        endif
c        U(i)=real(i-p-1)/real(n-1)
c      enddo
cc
c      nelem = CountSpans(n,p,U)
c      if(iinfo.eq.1)write(*,*)'nelem',nelem
c      if(iinfo.eq.1)write(*,*)'U',U
cc      nelem=nelem-2
c
c        deallocate(U)
c        allocate(U(n+p+2+(nelem/iblock)*(p-1)))
c        n=n+(nelem/iblock)*(p-1)
c        if(iinfo.eq.1)
c     .    write(*,*)'allocate(U(',n+p+1+(nelem/iblock)*(p-1),'))'
c        U(1:p+1)=0.d0 !1:4
c        i=p+2; l=1
c        if(iinfo.eq.1)
c     .     write(*,*)'IBLOCK,nelem',IBLOCK,nelem
c        do j=1,nelem/IBLOCK !36/18=2
c          do k=0,IBLOCK-p-1 !0,18-3=15, -> 5,20
c            if(iinfo.eq.1)
c     .        write(*,*)'U(',i+k,')=',real(l+k)/real(nelem)
c            U(i+k)=real(l+k)/real(nelem)
c          enddo
cc          if(j.lt.nelem/IBLOCK)then
c            do k=IBLOCK-p,IBLOCK !18-3-1=14,18
c              if(iinfo.eq.1)
c     .          write(*,*)'*U(',i+k,')=',real(l+IBLOCK-p+1)/real(nelem)
c              U(i+k)=real(l+IBLOCK-p+1)/real(nelem)
c            enddo
c            i=i+IBLOCK+1;l=l+IBLOCK-p+2
cc          else
cc            i=i+IBLOCK+1-p
cc          endif
c        enddo
c        U(i:i+p)=1.d0
c        if(iinfo.eq.1)then
c          write(*,*)'n,p,nelem',n,p,nelem
c          write(*,*)'U',U
c        endif
c      endif
c----------------------------------------------------------------------
      if(iblock.gt.0.and.p.eq.3)then
        allocate(U(n+2*p)) !knot vector
        U(1:p+1)=0.d0
        U(n+p:n+2*p)=1.d0
        do i=p+2,n+p-1
c         if(iprint.eq.1)then
c         write(*,*)'i-p-1,n,(i-p-1)/(n)',i-p-1,n,real(i-p-1)/real(n) !n-1 is number of intervals
c         endif
         U(i)=real(i-p-1)/real(n-1)
        enddo
c
        nelem = CountSpans(n,p,U)
        if(iinfo.eq.1)write(*,*)'nelem',nelem
        if(iinfo.eq.1)write(*,*)'U',U

        deallocate(U)
        allocate(U(n+p+2+(nelem/iblock)*(p-1)+10))
        n=n+(nelem/iblock)*(p-1)
c        write(*,*)'allocate(U(',n+p+1+(nelem/iblock)*(p-1),'))'
        U(1:p+1)=0.d0
        i=p+2; l=1
        if(iinfo==1)write(*,*)'IBLOCK,nelem',IBLOCK,nelem
        do j=1,nelem/IBLOCK
          do k=0,IBLOCK-p
            if(iinfo==1)write(*,*)'U(',i+k,')=',real(l+k)/real(nelem)
            U(i+k)=real(l+k)/real(nelem)
          enddo
          do k=IBLOCK-p+1,IBLOCK
            if(iinfo==1)
     .        write(*,*)'*U(',i+k,')=',real(l+IBLOCK-p+1)/real(nelem)
            U(i+k)=real(l+IBLOCK-p+1)/real(nelem)
          enddo
          i=i+IBLOCK+1;l=l+IBLOCK-p+2
        enddo
        do k=0,IBLOCK-p
          if(iinfo==1)write(*,*)'U(',i+k,')=',real(l+k)/real(nelem)
          U(i+k)=real(l+k)/real(nelem)
        enddo
        i=i+IBLOCK-p+1
        U(i:i+p)=1.d0
        if(iinfo.eq.1)then
          write(*,*)'n,p,nelem',n,p,nelem
          write(*,*)'U',U
        endif
      endif
c----------------------------------------------------------------------
c----------------------------------------------------------------------
      if(iblock.gt.0.and.p.eq.4)then
        allocate(U(n+2*p)) !knot vector
        U(1:p+1)=0.d0
        U(n+p:n+2*p)=1.d0
        do i=p+2,n+p-1
c         if(iprint.eq.1)then
c         write(*,*)'i-p-1,n,(i-p-1)/(n)',i-p-1,n,real(i-p-1)/real(n) !n-1 is number of intervals
c         endif
         U(i)=real(i-p-1)/real(n-1)
        enddo
c
        nelem = CountSpans(n,p,U)
        if(iinfo.eq.1)write(*,*)'nelem',nelem
        if(iinfo.eq.1)write(*,*)'U',U

        deallocate(U)
        allocate(U(n+p+2+(nelem/iblock)*(p-1)))
        n=n+(nelem/iblock)*(p-1)
c        write(*,*)'allocate(U(',n+p+1+(nelem/iblock)*(p-1),'))'
        U(1:p+1)=0.d0
        i=p+2; l=1
        if(iinfo==1)write(*,*)'IBLOCK,nelem',IBLOCK,nelem
        do j=1,nelem/IBLOCK
          do k=0,IBLOCK-p
            if(iinfo==1)write(*,*)'U(',i+k,')=',real(l+k)/real(nelem)
            U(i+k)=real(l+k)/real(nelem)
          enddo
          do k=IBLOCK-p+1,IBLOCK
            if(iinfo==1)
     .        write(*,*)'*U(',i+k,')=',real(l+IBLOCK-p+1)/real(nelem)
            U(i+k)=real(l+IBLOCK-p+1)/real(nelem)
          enddo
          i=i+IBLOCK+1;l=l+IBLOCK-p+2
        enddo
        do k=0,IBLOCK-p
          if(iinfo==1)write(*,*)'U(',i+k,')=',real(l+k)/real(nelem)
          U(i+k)=real(l+k)/real(nelem)
        enddo
        i=i+IBLOCK-p+1
        U(i:i+p)=1.d0
        if(iinfo.eq.1)then
          write(*,*)'n,p,nelem',n,p,nelem
          write(*,*)'U',U
        endif
      endif
c----------------------------------------------------------------------
c----------------------------------------------------------------------

c<- rIGA

c
      if(SIZE<NRPROCX.or.SIZE<NRPROCY.or.SIZE<NRPROCZ)then
        write(*,*)'Number of elements smaller than number of processors'
        stop
      endif
c      allocate(U(n+p+2)) !knot vector
      KL=p; KU=p
c PARALLEL - distributed
c number of columns per processors
      nrcppx = (n+1+1)/NRPROCX+1
c      nrcppx = (n+p+1+(nelem/iblock)*(p-1))/NRPROCX
      if(MYRANKX.eq.NRPROCX-1)then
        ibegx = nrcppx*(NRPROCX-1)+1
        iendx = n+1
      else
        ibegx = nrcppx*(NRPROCX-2)+1
        iendx = nrcppx*(NRPROCX-1)
      endif
      nrcppy = (n+1+1)/NRPROCY+1
c      nrcppy = (n+p+1+(nelem/iblock)*(p-1))/NRPROCY
      if(MYRANKY.eq.NRPROCY-1)then
        ibegy = nrcppy*(NRPROCY-1)+1
        iendy = n+1
      else
        ibegy = nrcppy*(NRPROCY-2)+1
        iendy = nrcppy*(NRPROCY-1)
      endif
      nrcppz = (n+1+1)/NRPROCZ+1
c      nrcppz = (n+p+1+(nelem/iblock)*(p-1))/NRPROCZ
      if(MYRANKZ.eq.NRPROCZ-1)then
        ibegz = nrcppz*(NRPROCZ-1)+1
        iendz = n+1
      else
        ibegz = nrcppz*(NRPROCZ-2)+1
        iendz = nrcppz*(NRPROCZ-1)
      endif

      if(iinfo.eq.1)then
        write(*,*)'Number of columns per processor:',MYRANK
        write(*,*)'ibegx,iendx',ibegx,iendx
        write(*,*)'ibegy,iendy',ibegy,iendy
        write(*,*)'ibegz,iendz',ibegz,iendz
      endif
c
c ....prepare dimensions vectors
      allocate(dimensionsX(NRPROCX))
      allocate(shiftsX(NRPROCX))
      shiftsX=0;dimensionsX=0
      do i=1,NRPROCX-1
        dimensionsX(i)=nrcppx*(iendy-ibegy+1)*(iendz-ibegz+1)
        if(i.gt.1)shiftsX(i)=shiftsX(i-1)+dimensionsX(i-1)
      enddo
      dimensionsX(NRPROCX)=((n+1)-nrcppx*(NRPROCX-1))*
     .   (iendy-ibegy+1)*(iendz-ibegz+1)
      shiftsX(NRPROCX)=shiftsX(NRPROCX-1)+dimensionsX(NRPROCX-1)
      allocate(dimensionsY(NRPROCY))
      allocate(shiftsY(NRPROCY))
      shiftsY=0;dimensionsY=0
      do i=1,NRPROCY-1
        dimensionsY(i)=nrcppy*(iendx-ibegx+1)*(iendz-ibegz+1)
        if(i.gt.1)shiftsY(i)=shiftsY(i-1)+dimensionsY(i-1)
      enddo
      dimensionsY(NRPROCY)=((n+1)-nrcppy*(NRPROCY-1))*
     .   (iendx-ibegx+1)*(iendz-ibegz+1)
      shiftsY(NRPROCY)=shiftsY(NRPROCY-1)+dimensionsY(NRPROCY-1)
      allocate(dimensionsZ(NRPROCZ))
      allocate(shiftsZ(NRPROCZ))
      shiftsZ=0;dimensionsZ=0
      do i=1,NRPROCZ-1
        dimensionsZ(i)=nrcppy*(iendx-ibegx+1)*(iendy-ibegy+1)
        if(i.gt.1)shiftsZ(i)=shiftsZ(i-1)+dimensionsZ(i-1)
      enddo
      dimensionsZ(NRPROCZ)=((n+1)-nrcppz*(NRPROCZ-1))*
     .   (iendx-ibegx+1)*(iendy-ibegy+1)
      shiftsZ(NRPROCZ)=shiftsZ(NRPROCZ-1)+dimensionsZ(NRPROCZ-1)
c  ...check
      if(idebug.eq.1)then
      k=0
      do i=1,NRPROCX
        k=k+dimensionsX(i)
      enddo
      if(k.ne.(n+1)*(iendy-ibegy+1)*(iendz-ibegz+1))then
        write(*,*)PRINTRANK,'problem with dimensionsX',dimensionsX
        write(*,*)PRINTRANK,'n+1',n+1
        write(*,*)PRINTRANK,'(iendy-ibegy+1)',iendy-ibegy+1
        write(*,*)PRINTRANK,'(iendz-ibegz+1)',iendz-ibegz+1
        write(*,*)PRINTRANK,'nrcppx',nrcppx
        stop
      endif
      k=0
      do i=1,NRPROCY
        k=k+dimensionsY(i)
      enddo
      if(k.ne.(n+1)*(iendx-ibegx+1)*(iendz-ibegz++1))then
        write(*,*)PRINTRANK,'problem with dimensionsY',dimensionsY
        write(*,*)PRINTRANK,'n+1',n+1
        write(*,*)PRINTRANK,'(iendx-ibegx+1)',iendx-ibegx+1
        write(*,*)PRINTRANK,'(iendz-ibegz+1)',iendz-ibegz+1
        stop
      endif
      k=0
      do i=1,NRPROCZ
        k=k+dimensionsZ(i)
      enddo
      if(k.ne.(n+1)*(iendx-ibegx+1)*(iendy-ibegy+1))then
        write(*,*)PRINTRANK,'problem with dimensionsZ',dimensionsZ
        write(*,*)PRINTRANK,'n+1',n+1
        write(*,*)PRINTRANK,'(iendx-ibegx+1)',iendx-ibegx+1
        write(*,*)PRINTRANK,'(iendy-ibegy+1)',iendy-ibegy+1
        stop
      endif
      endif     
c

      if(iprint.eq.1)then
        write(*,*)PRINTRANK,
     .     'MYRANKX,MYRANKY,MYRANKZ',MYRANKX,MYRANKY,MYRANKZ
        write(*,*)PRINTRANK,
     .    'NRPROCX,NRPROCY,NRPROCZ',NRPROCX,NRPROCY,NRPROCZ
        write(*,*)PRINTRANK,'n+1',n+1
        write(*,*)PRINTRANK,'nrcppx,nrcppy,nrcppz',nrcppx,nrcppy,nrcppz
        write(*,*)PRINTRANK,'ibegx,iendx',ibegx,iendx
        write(*,*)PRINTRANK,'ibegy,iendy',ibegy,iendy
        write(*,*)PRINTRANK,'ibegz,iendz',ibegz,iendz
      endif

      call mpi_barrier(MPI_COMM_WORLD,ierr)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c----------------------------------------------------------------------
c  ...set an MPI communicator for all MUMPS processors
      mumps_par%comm = MPI_COMM_WORLD
c
c  ...indicate that host processor should participate in the
c     factorization and solve phases 
      mumps_par%par = 1
c
c     symmetric and positive definite (2 = general symmetric)
      mumps_par%sym = 0

      mumps_par%job = -1

      call dmumps(mumps_par)

      if (MUMPS_PAR%MYID == 0) then
        MUMPS_PAR%N = (n+1)*(n+1)*(n+1)
        write(*,*)PRINTRANK,'N',MUMPS_PAR%N
        allocate( MUMPS_PAR%RHS(MUMPS_PAR%N))
        MUMPS_PAR%NRHS=1
      endif      
c----------------------------------------------------------------------
c  ...generate the local part of global matrix 
c
c*************************************************************************
c********************** Inicjalizacja koniec *****************************
c*************************************************************************

      call stop_clock(dtime,iclock)
      write(*,*) 'dtime : ', dtime
      if (measure.eq.1) then
         call PAPIF_flops(real_time, proc_time, flpins,mflops,retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write (*,*) 'init stage finished with'
         write (*,100) real_time, proc_time, flpins, mflops
      endif
      if (measure.eq.2) then
         call PAPIF_read_counters(values, numevents, retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write (*,*) 'init stage finished with'
         write (*,*) 'Mem loads : ', values(1),
     .     '  Mem store : ', values(2),
     .     '  MYRANK : ', MYRANK
      endif

c*************************************************************************
c********************** Calkowanie ***************************************
c*************************************************************************

      call mpi_barrier(MPI_COMM_WORLD,ierr)

      call FormMassMatrix
     . (U,p,n,nelem,U,p,n,nelem,U,p,n,nelem,
     .  ibegx,iendx,MYRANKX,NRPROCX,
     .  ibegy,iendy,MYRANKY,NRPROCY,
     .  ibegz,iendz,MYRANKZ,NRPROCZ,
     .  MUMPS_PAR%IRN_loc,MUMPS_PAR%JCN_loc,MUMPS_PAR%A_loc,nr_nonzeros)
c
c  ...generate the local part of RHS vectors
c
      call mpi_barrier(MPI_COMM_WORLD,ierr)

      if (MUMPS_PAR%MYID == 0) then
        MUMPS_PAR%RHS=0
        call Form3DRHS
     .   (U,p,n,nelem,U,p,n,nelem,U,p,n,nelem,MUMPS_PAR%RHS)
      endif

c*************************************************************************
c********************** Calkowanie koniec ********************************
c*************************************************************************     
          
      call stop_clock(dtime,iclock)
      write(*,*) 'dtime : ', dtime
      if (measure.eq.1) then
         call PAPIF_flops(real_time, proc_time, flpins,mflops,retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write (*,*) 'integration stage finished with'
         write (*,100) real_time, proc_time, flpins, mflops
      endif
      if (measure.eq.2) then
         call PAPIF_read_counters(values, numevents, retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write (*,*) 'integration stage finished with'
         write (*,*) 'Mem loads : ', values(1),
     .     '  Mem store : ', values(2),
     .     '  MYRANK : ', MYRANK
      endif
      
      call mpi_barrier(MPI_COMM_WORLD,ierr)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  ...solve the problem
c
      call mpi_barrier(MPI_COMM_WORLD,ierr)
c
c ....mumps call
c      write(*,*)PRINTRANK,'IRN,JCN,A'
c      write(*,*)PRINTRANK,IRN(1:nr_nonzeros)
c      write(*,*)PRINTRANK,JCN(1:nr_nonzeros)
c      write(*,*)PRINTRANK,A(1:nr_nonzeros)

c     error output stream (non-positive to suppress)
      mumps_par%icntl(1)  = 1 !1
c     diagnostic, statistics and warnings
      mumps_par%icntl(2)  = 1 !1
c     global information
      mumps_par%icntl(3)  = 6 !6
c     printing level
      mumps_par%icntl(4)  = 3 !3
c     input matrix in assembled or element format
      mumps_par%icntl(5)  = 0
c     column permutation for zero-free diagonal (automatic)
c      mumps_par%icntl(6)  = 7
c     pivot order (automatic)
      mumps_par%icntl(7)  = 5 !1 enforce ordering, 5 metis, 0 AMD, 7 auto
c     scaling (automatic)
c      mumps_par%icntl(8)  = 7
c     no transpose
c      mumps_par%icntl(9)  = 1
c     max steps for iterative refinement
c      mumps_par%icntl(10) = 0
c     statistics info
c      mumps_par%icntl(11) = 0
c     controls parallelism
      mumps_par%icntl(12) = 0
c     use ScaLAPACK for root node
      mumps_par%icntl(13) = 1 !0 use 1 do not use
c     percentage increase in estimated workspace
      mumps_par%icntl(14) = 100 !4000 too small 5000 too big
c     matrix distribution for assembled input
      mumps_par%icntl(18) = 3 !distributed
c     nonzero for Schur complement
      mumps_par%icntl(19) = 0
c     distribution of RHS (centralized on host)
      mumps_par%icntl(20) = 0
c      mumps_par%sym = 2

c------------------------------------------------------------------------------
c  ...fill the matrices
      MUMPS_PAR%NZ_loc = nr_nonzeros
      
c------------------------------------------------------------------------------

      call mpi_barrier(MPI_COMM_WORLD,ierr)

c*************************************************************************
c********************** Analiza MUMPS ************************************
c*************************************************************************

c ANALYSIS
      mumps_par%job = 1
      call dmumps(mumps_par)
c
c      write(*,*)PRINTRANK,'mumps_par%MYID',mumps_par%MYID
c      write(*,*)PRINTRANK,'mumps_par%NZ_loc',mumps_par%NZ_loc
c      write(*,*)PRINTRANK,'mumps_par%N',mumps_par%N
c      write(*,*)PRINTRANK,'mumps_par%NRHS',mumps_par%NRHS
c      if(MYRANK.eq.0)then
c        write(*,*)PRINTRANK,'IRN',mumps_par%IRN_loc(1:mumps_par%NZ_loc)
c        write(*,*)PRINTRANK,'JCN',mumps_par%JCN_loc(1:mumps_par%NZ_loc)
c        write(*,*)PRINTRANK,'A',mumps_par%A_loc(1:mumps_par%NZ_loc)
c      endif
      
c*************************************************************************
c********************** Analiza MUMPS koniec *****************************
c*************************************************************************
          
      call stop_clock(dtime,iclock)
      write(*,*) 'dtime : ', dtime
      if (measure.eq.1) then
         call PAPIF_flops(real_time, proc_time, flpins,mflops,retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write (*,*) 'analyzsis stage finished with'
         write (*,100) real_time, proc_time, flpins, mflops
      endif
      if (measure.eq.2) then
         call PAPIF_read_counters(values, numevents, retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write (*,*) 'analysis stage finished with'
         write (*,*) 'Mem loads : ', values(1),
     .     '  Mem store : ', values(2),
     .     '  MYRANK : ', MYRANK
      endif
      
      call mpi_barrier(MPI_COMM_WORLD,ierr)
            
c
c*************************************************************************
c********************** Faktoryzacja MUMPS *******************************
c*************************************************************************

c FACTORIZATION
      mumps_par%job = 2
      call dmumps(mumps_par)

      if (mumps_par%info(1).ne.0) then
        write (*,*) 'mumps_par%job=',mumps_par%job
        write (*,*) 'mumps_par%info=',mumps_par%info
        stop1
      endif
c
c  ...host processor
      if (MUMPS_PAR%MYID == 0) then
c
c  .....check for errors
        if (mumps_par%info(1).ne.0) then
          write (*,*) 'mumps_par%job=',mumps_par%job
          write (*,*) 'mumps_par%info=',mumps_par%info
          stop1
        endif
c
        if (iprint>=1) then
          write(*,1002) dtime
 1002          format('MUMPS SOLUTION TIME:      ',f9.4,'s')
        endif
c
c  .....print statistical information
        if (mumps_par%icntl(11)>0) then
          write(*,1010) mumps_par%rinfog(10)
          write(*,1011) mumps_par%rinfog(11)
 1010          format('cond1(A) = ',e15.8)
 1011               format('cond2(A) = ',e15.8)
        endif
      endif
      
            
c*************************************************************************
c********************** Faktoryzacja MUMPS koniec ************************
c*************************************************************************
          
      call stop_clock(dtime,iclock)
      write(*,*) 'dtime : ', dtime
      if (measure.eq.1) then
         call PAPIF_flops(real_time, proc_time, flpins,mflops,retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write (*,*) 'factoryzation stage finished with'
         write (*,100) real_time, proc_time, flpins, mflops
      endif
      if (measure.eq.2) then
         call PAPIF_read_counters(values, numevents, retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write (*,*) 'factoryzation stage finished with'
         write (*,*) 'Mem loads : ', values(1),
     .     '  Mem store : ', values(2),
     .     '  MYRANK : ', MYRANK
      endif


c*************************************************************************
c********************** BS MUMPS *****************************************
c*************************************************************************


      call mpi_barrier(MPI_COMM_WORLD,ierr)

      mumps_par%job = 3
      call dmumps(mumps_par)

c  ...check for errors
      if (mumps_par%info(1).ne.0) then
        write (*,*) 'mumps_par%job=',mumps_par%job
        write (*,*) 'mumps_par%info=',mumps_par%info
        stop1
      endif
      
c*************************************************************************
c********************** BS MUMPS koniec **********************************
c*************************************************************************      
      
          
      call stop_clock(dtime,iclock)
      write(*,*) 'dtime : ', dtime
      if (measure.eq.1) then
         call PAPIF_flops(real_time, proc_time, flpins,mflops,retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write (*,*) 'BS stage finished with'
         write (*,100) real_time, proc_time, flpins, mflops
      endif
      if (measure.eq.2) then
         call PAPIF_read_counters(values, numevents, retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write (*,*) 'BS stage finished with'
         write (*,*) 'Mem loads : ', values(1),
     .     '  Mem store : ', values(2),
     .     '  MYRANK : ', MYRANK
      endif
      
      
c
      call mpi_barrier(MPI_COMM_WORLD,ierr)
c
c  ...terminate an instance of MUMPS
      mumps_par%job = -2

      call dmumps(mumps_par)

      call mpi_barrier(MPI_COMM_WORLD,ierr)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      deallocate(shiftsX)
      deallocate(shiftsY)
      deallocate(shiftsZ)
c
      deallocate(dimensionsX)
      deallocate(dimensionsY)
      deallocate(dimensionsZ)
c
      if(allocated(IPIV))deallocate(IPIV)
c      deallocate(U)
c      deallocate(M)
c      deallocate(F)
c
      deallocate(mumps_par%IRN_loc)
      deallocate(mumps_par%JCN_loc)
      deallocate(mumps_par%A_loc)
      if(MYRANK.eq.0)deallocate(mumps_par%RHS)
c
c      if(MYRANK.eq.0)iprint=1=
      if(iprint.eq.1)then
        write(*,*)PRINTRANK,'Result:'
        do i=1,iendz-ibegz+1
          write(*,*)PRINTRANK,i,
     .     'row=',Result(i,1:(iendx-ibegx+1)*(iendy-ibegy+1))
        enddo
      endif
c
      call mpi_barrier(MPI_COMM_WORLD,ierr)
      call mpi_finalize(ierr)
      if(iinfo.eq.1)write(*,*)PRINTRANK,"Exiting..."
c
      if(MYRANK.eq.0)then
      call stop_clock(dtime,iclock)
      write(*,*) 'dtime : ', dtime
      endif
      
      if(MYRANK.eq.0)then
         write (*,*) 'stop time'
         call timestamp('stop')
      endif
      
      if (measure.eq.1) then
         call PAPIF_flops(real_time, proc_time, flpins,mflops,retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write (*,100) real_time, proc_time, flpins, mflops
      endif
      if (measure.eq.2) then
         call PAPIF_stop_counters(values, numevents, retval)
         if ( retval .ne. PAPI_OK ) then
            call PAPIF_perror(retval, errorstring, PAPI_MAX_STR_LEN)
            print *, errorstring
            call exit(1)
         endif
         write (*,*) 'Mem loads : ', values(1),
     .     '  Mem store : ', values(2),
     .     '  MYRANK : ', MYRANK
      endif
      
100   format('           Real time (secs) :', f15.3, 
     +      /'            CPU time (secs) :', f15.3,
     +      /'Floating point instructions :', i15,
     +      /'                     MFLOPS :', f15.3)
     
200   format('           Mem loads :', f20.0, 
     +      /'           Mem store :', f20.0)
      
c
      end




